/* Copyright    Massachusetts Institute of Technology    1985	*/

#include "XlibInternal.h"
QueryCrabs ()
{
	register Display *dpy;
	register int i;
	register OpaqueFrame *frame = defs;
	int nresult = 0;

	for (i=0;i<crab_count;i++) {
	    register XReq *req;
	    GetReq(X_PixmapGet, w);
	    req -> func = XYFormat;
	    req->param.s[0] = CRABSIZE;
	    req->param.s[1] = CRABSIZE;
	    req->param.s[2] = nearest(crab_buf[i].x);
	    req->param.s[3] = nearest(crab_buf[i].y);
	    }
	
	/* Reset request number to its old value, so that
	    error packets are processed correctly.  */
	dpy->request -= ndefs;

	frame = defs;
	for (i=0;i<ndefs;i++) {
	    XRep rep;
	    /* Increment request number so error packets
	       are processed correctly. */
	    dpy->request++;
	    if (!_XReply(dpy, &rep))
	    	error();
	    else {
	        _XRead(dpy, buf, 
		       XYPixmapSize(CRABSIZE, CRABSIZE, dpy->dplanes));
		for (j=16; i; )
		  { --j;
		    if(crab_buf[i].notongray = 
		        ((short) buf[i] != (short) gr_bits[i])) break;
		  }
		nresult++;
		}
	    }
	return (nresult);
}
